#!/bin/sh
# synclient wrapper for Lucid Puppy 5.1
# 23 aug 2010 shinobar
TITLE="Synclient"
APPDATADIR="/usr/share/synclient"
[ "$DISPLAY" != "" ] || exec synclient.bin "$@"
# i18n
export TEXDOMAIN="synclient"
export OUTPUT_CHARSET=UTF-8
#
errmsg() {
  export MAIN_DIALOG="<window title=\"$TITLE\"><vbox>
    <text><input>echo -e -n \"$@\"</input></text>
	<button ok></button>
	</vbox></window>"
  gtkdialog3
}
TOUCHPAD=""
for T in Elantech Alps Synaptics; do
   grep -F -q "$T" /proc/bus/input/devices && TOUCHPAD="$T"
done
if [ "$TOUCHPAD" = "" ];then
  pidof flsynclient &>/dev/null && killall flsynclient
  errmsg $(gettext 'No Synaptics touchpad supported found.')
  exit
fi
# registar on rc.local
grep -q '^[[:blank:]]*modprobe evdev' /etc/rc.d/rc.local || echo "modprobe evdev" >> /etc/rc.d/rc.local

# check validity of xorg.conf
if ! grep -q '^[[:blank:]]*InputDevice.*Synaptics' /etc/X11/xorg.conf ; then
  # register on xorg.conf 
  KEYREVERT=""
  cp -f /etc/X11/xorg.conf /tmp/xorg.conf
  if ! grep -q 'Section.*ServerLayout'  /etc/X11/xorg.conf ; then
    cat "$APPDATADIR/xorg.conf2-layout" >> /tmp/xorg.conf
  fi
  if ! grep -q 'Identifier.*Keyboard0'  /etc/X11/xorg.conf ; then
    cat "$APPDATADIR/xorg.conf2-keyboard" >> /tmp/xorg.conf
    KEYREVERT="yes"
  fi
  if ! grep -q 'Identifier.*Mouse0'  /etc/X11/xorg.conf ; then
    cat "$APPDATADIR/xorg.conf2-mouse" >> /tmp/xorg.conf
  fi
  if ! grep -q 'Identifier.*Synaptics Mouse'  /etc/X11/xorg.conf ; then
    cat "$APPDATADIR//xorg.conf2-$TOUCHPAD" >> /tmp/xorg.conf
  fi
  [ -s /tmp/xorg.conf ] && cp -f /etc/X11/xorg.conf /etc/X11/xorg.conf.bak && cp -f /tmp/xorg.conf /etc/X11/xorg.conf
  [ "$KEYREVERT" != "" ] && which keymap-set &>/dev/null && keymap-set --load
fi
# SHM accessible?
if grep -q 'Option.*SHMConfig.*on' /var/log/Xorg.0.log ; then
  exec synclient.bin "$@"
fi

pidof flsynclient &>/dev/null && killall flsynclient
MSG=$(printf "$(gettext '%s touchpad found.')" $TOUCHPAD)
MSG="$MSG $(gettext 'But you need to restart X-server to control it from synclient.')"
errmsg "$MSG"
exit